diff -pruN 1.16.3+dfsg-3/debian/changelog 1.16.3+dfsg-4/debian/changelog
--- 1.16.3+dfsg-3/debian/changelog	2024-05-30 08:15:32.000000000 +0000
+++ 1.16.3+dfsg-4/debian/changelog	2024-07-06 15:57:45.000000000 +0000
@@ -1,3 +1,9 @@
+onnxruntime (1.16.3+dfsg-4) unstable; urgency=medium
+
+  * Add patches fixing FTBFS with GCC-14 (Closes: #1075334)
+
+ -- Dylan Aïssi <daissi@debian.org>  Sat, 06 Jul 2024 17:57:45 +0200
+
 onnxruntime (1.16.3+dfsg-3) unstable; urgency=medium
 
   * Upload to unstable
diff -pruN 1.16.3+dfsg-3/debian/patches/fix-cxx20-template-constructor.patch 1.16.3+dfsg-4/debian/patches/fix-cxx20-template-constructor.patch
--- 1.16.3+dfsg-3/debian/patches/fix-cxx20-template-constructor.patch	1970-01-01 00:00:00.000000000 +0000
+++ 1.16.3+dfsg-4/debian/patches/fix-cxx20-template-constructor.patch	2024-07-06 15:57:45.000000000 +0000
@@ -0,0 +1,24 @@
+Description: Fix C++20 template constructor
+Forwarded: https://github.com/microsoft/onnxruntime/pull/21057
+Origin: https://src.fedoraproject.org/rpms/onnxruntime/blob/f40/f/fix-cxx20-template-constructor.patch
+Author: Alejandro Álvarez Ayllón <a.alvarezayllon@gmail.com>
+
+--- a/onnxruntime/core/providers/cpu/ml/tree_ensemble_aggregator.h
++++ b/onnxruntime/core/providers/cpu/ml/tree_ensemble_aggregator.h
+@@ -326,11 +326,11 @@
+ template <typename InputType, typename ThresholdType, typename OutputType>
+ class TreeAggregatorMax : public TreeAggregator<InputType, ThresholdType, OutputType> {
+  public:
+-  TreeAggregatorMax<InputType, ThresholdType, OutputType>(size_t n_trees,
+-                                                          const int64_t& n_targets_or_classes,
+-                                                          POST_EVAL_TRANSFORM post_transform,
+-                                                          const std::vector<ThresholdType>& base_values) : TreeAggregator<InputType, ThresholdType, OutputType>(n_trees, n_targets_or_classes,
+-                                                                                                                                                                post_transform, base_values) {}
++  TreeAggregatorMax(size_t n_trees,
++                    const int64_t& n_targets_or_classes,
++                    POST_EVAL_TRANSFORM post_transform,
++                    const std::vector<ThresholdType>& base_values) : TreeAggregator<InputType, ThresholdType, OutputType>(n_trees, n_targets_or_classes,
++                                                                                                                          post_transform, base_values) {}
+ 
+   // 1 output
+ 
diff -pruN 1.16.3+dfsg-3/debian/patches/gcc-false-positive.patch 1.16.3+dfsg-4/debian/patches/gcc-false-positive.patch
--- 1.16.3+dfsg-3/debian/patches/gcc-false-positive.patch	1970-01-01 00:00:00.000000000 +0000
+++ 1.16.3+dfsg-4/debian/patches/gcc-false-positive.patch	2024-07-06 15:57:45.000000000 +0000
@@ -0,0 +1,38 @@
+Description: Ignore GCC false positives
+Forwarded: not-needed
+Origin: https://src.fedoraproject.org/rpms/onnxruntime/blob/f40/f/gcc-false-positive.patch
+Author: Alejandro Álvarez Ayllón <a.alvarezayllon@gmail.com>
+
+--- a/onnxruntime/core/providers/cpu/tensor/scatter.cc
++++ b/onnxruntime/core/providers/cpu/tensor/scatter.cc
+@@ -16,6 +16,8 @@
+ #include "orttraining/training_ops/cpu/tensor/gather_elements_grad_impl.h"
+ #endif
+ 
++#pragma GCC diagnostic ignored "-Warray-bounds"
++
+ namespace onnxruntime {
+ 
+ namespace op_kernel_type_control {
+--- a/onnxruntime/test/framework/sparse_kernels_test.cc
++++ b/onnxruntime/test/framework/sparse_kernels_test.cc
+@@ -27,6 +27,8 @@
+ #include "core/util/math_cpuonly.h"
+ #include <Eigen/SparseCore>
+ 
++#pragma GCC diagnostic ignored "-Wdangling-reference"
++
+ using namespace ONNX_NAMESPACE;
+ using namespace onnxruntime::common;
+ 
+--- a/onnxruntime/core/optimizer/selectors_actions/selector_action_transformer.cc
++++ b/onnxruntime/core/optimizer/selectors_actions/selector_action_transformer.cc
+@@ -1,6 +1,8 @@
+ // Copyright (c) Microsoft Corporation. All rights reserved.
+ // Licensed under the MIT License.
+ 
++#pragma GCC diagnostic ignored "-Wmaybe-uninitialized"
++
+ #include "core/optimizer/selectors_actions/selector_action_transformer.h"
+ 
+ #include <cassert>
diff -pruN 1.16.3+dfsg-3/debian/patches/series 1.16.3+dfsg-4/debian/patches/series
--- 1.16.3+dfsg-3/debian/patches/series	2024-05-30 08:15:32.000000000 +0000
+++ 1.16.3+dfsg-4/debian/patches/series	2024-07-06 15:57:45.000000000 +0000
@@ -14,5 +14,7 @@ system-datadir.patch
 system-benchmark.patch
 Disable-AVX-tests-on-non-AMD64.patch
 Disable-failing-tests-on-ARM32.patch
+fix-cxx20-template-constructor.patch
+gcc-false-positive.patch
 
 17eaf9b053238b3efec303e9c94008201ca42462.patch
